"""autogenerated by genpy from riq_msgs/RIQHandState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import riq_msgs.msg

class RIQHandState(genpy.Message):
  _md5sum = "3ab70f8c0e9b67b0db99e45af2360afc"
  _type = "riq_msgs/RIQHandState"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ROS state information from RobotIQ hand

# Action status
int8 FAULTED              = 0
int8 IN_PROGRESS          = 1
int8 ILLEGAL_OR_UNDEFINED = 2
int8 SUCCESSFUL           = 3

# Mode constants
int8 CYLINDRICAL = 0
int8 PINCH       = 1
int8 SPHERIOD    = 2
int8 SCISSORS    = 3

# Grip
int8 STOPPED   = 0
int8 OPENED    = 1
int8 CLOSED    = 2
int8 INITIALIZING_OR_CHANGING = 3

# Object detection status
int8 NOT_DETECTED         = 0
int8 DETECTED_1_FINGER    = 1
int8 DETECTED_2_FINGERS   = 2
int8 DETECTED_ALL_FINGERS = 3


bool    operational  # True when RIQ hand is operational, 
                     # False if there is an error, or hand has not been initialized

int8    status       # Result of last requested action
                     #  SUCCESSFULL, FAULTED, IN_PROGRESS, ILLEGAL_OR_UNDEFINED

int8    mode         # Mode gripper is curretly in:     
                     #  PINCH, CYLINDRICAL, SPHERIOD, SCISSORS 

int8    grip         # Grip
                     #  CLOSED, OPEN, STOPPED, INTIALIZING_OR_CHANGING

int8    object       # Object detection
                     #  NOT_DETECTED, DETECTED_1_FINGER, DETECTED_2_FINGERS, DETECTED_ALL_FINGERS

RIQActuatorState thumb
RIQActuatorState right_finger
RIQActuatorState left_finger
RIQActuatorState scissors      # Scissors is joint motor between right and left finger
================================================================================
MSG: riq_msgs/RIQActuatorState
# ROS state information for RobotIQ actuator.

# Measured motor current (in Amps)
float64 current

# Motor position range from (0.0 to 1.0)
float64 position

# True when finger / actuator detected an object
bool object_detected
"""
  # Pseudo-constants
  FAULTED = 0
  IN_PROGRESS = 1
  ILLEGAL_OR_UNDEFINED = 2
  SUCCESSFUL = 3
  CYLINDRICAL = 0
  PINCH = 1
  SPHERIOD = 2
  SCISSORS = 3
  STOPPED = 0
  OPENED = 1
  CLOSED = 2
  INITIALIZING_OR_CHANGING = 3
  NOT_DETECTED = 0
  DETECTED_1_FINGER = 1
  DETECTED_2_FINGERS = 2
  DETECTED_ALL_FINGERS = 3

  __slots__ = ['operational','status','mode','grip','object','thumb','right_finger','left_finger','scissors']
  _slot_types = ['bool','int8','int8','int8','int8','riq_msgs/RIQActuatorState','riq_msgs/RIQActuatorState','riq_msgs/RIQActuatorState','riq_msgs/RIQActuatorState']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       operational,status,mode,grip,object,thumb,right_finger,left_finger,scissors

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RIQHandState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.operational is None:
        self.operational = False
      if self.status is None:
        self.status = 0
      if self.mode is None:
        self.mode = 0
      if self.grip is None:
        self.grip = 0
      if self.object is None:
        self.object = 0
      if self.thumb is None:
        self.thumb = riq_msgs.msg.RIQActuatorState()
      if self.right_finger is None:
        self.right_finger = riq_msgs.msg.RIQActuatorState()
      if self.left_finger is None:
        self.left_finger = riq_msgs.msg.RIQActuatorState()
      if self.scissors is None:
        self.scissors = riq_msgs.msg.RIQActuatorState()
    else:
      self.operational = False
      self.status = 0
      self.mode = 0
      self.grip = 0
      self.object = 0
      self.thumb = riq_msgs.msg.RIQActuatorState()
      self.right_finger = riq_msgs.msg.RIQActuatorState()
      self.left_finger = riq_msgs.msg.RIQActuatorState()
      self.scissors = riq_msgs.msg.RIQActuatorState()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_B4b2dB2dB2dB2dB.pack(_x.operational, _x.status, _x.mode, _x.grip, _x.object, _x.thumb.current, _x.thumb.position, _x.thumb.object_detected, _x.right_finger.current, _x.right_finger.position, _x.right_finger.object_detected, _x.left_finger.current, _x.left_finger.position, _x.left_finger.object_detected, _x.scissors.current, _x.scissors.position, _x.scissors.object_detected))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.thumb is None:
        self.thumb = riq_msgs.msg.RIQActuatorState()
      if self.right_finger is None:
        self.right_finger = riq_msgs.msg.RIQActuatorState()
      if self.left_finger is None:
        self.left_finger = riq_msgs.msg.RIQActuatorState()
      if self.scissors is None:
        self.scissors = riq_msgs.msg.RIQActuatorState()
      end = 0
      _x = self
      start = end
      end += 73
      (_x.operational, _x.status, _x.mode, _x.grip, _x.object, _x.thumb.current, _x.thumb.position, _x.thumb.object_detected, _x.right_finger.current, _x.right_finger.position, _x.right_finger.object_detected, _x.left_finger.current, _x.left_finger.position, _x.left_finger.object_detected, _x.scissors.current, _x.scissors.position, _x.scissors.object_detected,) = _struct_B4b2dB2dB2dB2dB.unpack(str[start:end])
      self.operational = bool(self.operational)
      self.thumb.object_detected = bool(self.thumb.object_detected)
      self.right_finger.object_detected = bool(self.right_finger.object_detected)
      self.left_finger.object_detected = bool(self.left_finger.object_detected)
      self.scissors.object_detected = bool(self.scissors.object_detected)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_B4b2dB2dB2dB2dB.pack(_x.operational, _x.status, _x.mode, _x.grip, _x.object, _x.thumb.current, _x.thumb.position, _x.thumb.object_detected, _x.right_finger.current, _x.right_finger.position, _x.right_finger.object_detected, _x.left_finger.current, _x.left_finger.position, _x.left_finger.object_detected, _x.scissors.current, _x.scissors.position, _x.scissors.object_detected))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.thumb is None:
        self.thumb = riq_msgs.msg.RIQActuatorState()
      if self.right_finger is None:
        self.right_finger = riq_msgs.msg.RIQActuatorState()
      if self.left_finger is None:
        self.left_finger = riq_msgs.msg.RIQActuatorState()
      if self.scissors is None:
        self.scissors = riq_msgs.msg.RIQActuatorState()
      end = 0
      _x = self
      start = end
      end += 73
      (_x.operational, _x.status, _x.mode, _x.grip, _x.object, _x.thumb.current, _x.thumb.position, _x.thumb.object_detected, _x.right_finger.current, _x.right_finger.position, _x.right_finger.object_detected, _x.left_finger.current, _x.left_finger.position, _x.left_finger.object_detected, _x.scissors.current, _x.scissors.position, _x.scissors.object_detected,) = _struct_B4b2dB2dB2dB2dB.unpack(str[start:end])
      self.operational = bool(self.operational)
      self.thumb.object_detected = bool(self.thumb.object_detected)
      self.right_finger.object_detected = bool(self.right_finger.object_detected)
      self.left_finger.object_detected = bool(self.left_finger.object_detected)
      self.scissors.object_detected = bool(self.scissors.object_detected)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_B4b2dB2dB2dB2dB = struct.Struct("<B4b2dB2dB2dB2dB")
